#include <iostream>
#include <iomanip>
#include <fstream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "cell-event.h"
#include "rof-event.h"

using namespace std;

//֐̐錾difinition of the function
void read2DValueText(ROF** fROF, int Ndays, int ROFnum_row, int ROFnum_col);
void read2DValueBinary(ROF** fROF, int Ndays, int ROFnum_row, int ROFnum_col);

int main()
{
	cout << "Reading parameters for runoff simulation." << endl;
	ifstream finParam("./param-averageRain-event.dat");
	if(!finParam){
		cout << "param-averageRain-event.dat cannot open." << endl;
	}

	// vZ̈ simulation range
	cout << "1) Reading parameters for study area." << endl;

	int wCol,wRow;
	float wSWLON, wSWLAT;

	finParam >> wCol; 
	finParam >> wRow; 
	cout << "  Number of col : " << wCol << "  Number of row : " << wRow << endl;

	finParam >> wSWLON; 
	finParam >> wSWLAT;
	cout << " Sorth West corner Longitude (degree) : " << wSWLON 
		 << " Latitude (deg) : " << wSWLAT << endl;

	const int Col = wCol;     // column number of study area
	const int Row = wRow;     // row number of study area
	const float SWLON = wSWLON; // South west corner of longitude (degree)
	const float SWLAT = wSWLAT; // South west corner of latiitude (degree)

	// ̓f[^̈ input data range
	cout << "2) Reading parameters for input data." << endl;

	int wROFnum_col, wROFnum_row;
	double wDelta_x, wDelta_y, wROF_WLON, wROF_SLAT;
	finParam >> wROFnum_col;
	finParam >> wROFnum_row;
	cout << "  Number of col : " << wROFnum_col 
		 << "  Number of row : " << wROFnum_row << endl;

	finParam >> wDelta_x;
	finParam >> wDelta_y;
	cout << "  Input data grid size of x-direction : " << wDelta_x << endl;
	cout << "  Input data grid size of y-direction : " << wDelta_y << endl;

	finParam >> wROF_WLON; 
	cout << "  Longitude of the center of the Southwest corner of input data (degree) : " << wROF_WLON << endl;
	finParam >> wROF_SLAT; 
	cout << "  Latitude of the center of the Southwest corner of input data (degree) : " << wROF_SLAT << endl;
													
	const int ROFnum_col = wROFnum_col;
	const int ROFnum_row = wROFnum_row; 
	const float Delta_x = wDelta_x;
	const float Delta_y = wDelta_y;
	const float ROF_WLON = wROF_WLON;
	const float ROF_SLAT = wROF_SLAT;

	// vZ simulation term
	cout << "3) Reading parameters for simuration duration." << endl;
	int wNdays;
	finParam >> wNdays;
	cout << "  Simulation duration (days) : " << wNdays << endl;

	const int Ndays = wNdays; // Simulation duration (days)

	finParam.close();
	//--------------------- end parameter reading ------------------------------------------------

	/*--- ~Jf[^pӂ set input data information ---*/
	// Memory assignment for data cell of input data
	class ROF** rofObject;
	rofObject = new class ROF*[ROFnum_row];
	for(int i=0; i<ROFnum_row; i++){
		rofObject[i] = new class ROF[ROFnum_col];
	}
	/*--- ̓f[^IuWFNgɏ ---*/
	//eIuWFNgɈܓxEox
	float ROFlat, ROFlon;
	for(int i=0; i<ROFnum_row; i++){
		//ROFlat = ROF_SLAT + 0.5*Delta_y + i*Delta_y ;  // set latitude
		ROFlat = ROF_SLAT + i*Delta_y ;  // set latitude. Runoff grid is the center.
		for(int j=0; j<ROFnum_col; j++){
			//ROFlon = ROF_WLON +  0.5*Delta_x + j*Delta_x; // set longitude 
			ROFlon = ROF_WLON +  j*Delta_x; // set longitude  Runoff grid is the center.
			rofObject[i][j].setInformation(&ROFlat, &ROFlon, Ndays);
		}
	}

	/*--- 敽ωJʂvZ闬ovZZpӂ set grid cell of simulation ---*/
	// Memory assignment for grid cell of simulation
	class Cell** cellObject; 
	cellObject = new class Cell*[Row];
	for(int i=0; i<Row; i++){
		cellObject[i] = new class Cell[Col];
	}
	/* latitude  longitude  longitudinalLength */
	FILE *fexBasin;
	//if(error = fopen_s(&fexBasin, "./topoData/extractBasin.bin", "rb") != NULL) {
	if ((fexBasin = fopen("./topoData/extractBasin.bin", "rb")) == NULL) {
		cout << "extractBasin.bin cannot open." << endl;
		exit(1);
	}

	for(int i=Row-1; i>=0; i--) { // DEM data arranges from south to north
		for(int j=0; j<Col; j++) {
			fread(&cellObject[i][j].riverKind, sizeof(int), 1, fexBasin);
			cellObject[i][j].setLocation(i, j, Row, Col, SWLAT, SWLON);
		}
	}
	fclose(fexBasin);


	/* connect cellObject and rofObject */
	for(int i=0; i<Row; i++){
		for(int j=0; j<Col; j++){
			// extractBasinŎw肵ɑȂObhɂ false ݒ肷B 
			if(cellObject[i][j].riverKind != 1){
				continue;
			}

			cellObject[i][j].setROFCell(rofObject, ROFnum_row, ROFnum_col);
		}
	}


	// --- ̓f[^̓ǂݍ read input data ---
	read2DValueText(rofObject, Ndays, ROFnum_row, ROFnum_col);
//	read2DValueBinary(rofObject, Ndays, ROFnum_row, ROFnum_col);

	//ʐςvZ.
	double area = 0.0;
	for(int m=0; m<Row; m++){
		for(int n=0; n<Col; n++){     // longitude direction from West
			// extractBasinŎw肵ɑȂObhɂ false ݒ肷B 
			if(cellObject[m][n].riverKind != 1){
				continue;
			}
			area += cellObject[m][n].longitudinalLength * 926.6;//[m^2]
		}
	}
	area *= 1.0e-6;//[m^2]-->[km^2]
	cout << "Basin area : " << area << " [km^2]" << endl;


	//~ʂvZăt@Cɏo͂.
	ofstream FileRainfall; // Hourly data
	char FileName[256];
	//sprintf_s(FileName, 256, "./output/dischargeHourly.bin");
	sprintf(FileName, "./output/averagedRain.dat");
	cout << "Write " << FileName << endl;
	FileRainfall.open(FileName, ios::out);

	area *= 1.0e12;//[km^2]-->[mm^2]
	double TotalRain = 0.0;
	for(int iday=1; iday <= Ndays; iday++){
		for (int ihour=0; ihour < 24; ihour++) {
			for(int m=0; m<Row; m++){
				for(int n=0; n<Col; n++){     // longitude direction from West
					// extractBasinŎw肵ɑȂObhɂ false ݒ肷B 
					if(cellObject[m][n].riverKind != 1){
						continue;
					}
					TotalRain += cellObject[m][n].ROFCell->value[iday][ihour]
							* cellObject[m][n].longitudinalLength * 1000.0
							* 926.6 * 1000.0;//[mm^3]
				}
			}
			TotalRain /= area;//[mm^3]-->[mm]
			FileRainfall << iday << " " << ihour+1 << " " << TotalRain << endl;

			TotalRain = 0.0;
		}
	}
	FileRainfall.close();


	for(int i=0; i<Row; i++){
		delete[] cellObject[i];
	}
	delete[] cellObject;


	return 0;
}


//	֐̒`
void read2DValueText(ROF** fROF, int Ndays, int ROFnum_row, int ROFnum_col)
{
	// read input data file arranged for two dimensional data. 

	char ROFfilename[256];

	//sprintf_s(ROFfilename, 256, "./input/rain.dat");
	sprintf(ROFfilename, "./input/rain.dat");
	cout << "Read " << ROFfilename << endl;

	ifstream fin(ROFfilename);
	if(!fin){
		cout << "ROF file cannot open.\n";
		exit(1);
	}

	int year, month, day, hour, xcol, yrow;
	for(int iday=1; iday <= Ndays; iday++){
		for(int ihour=0; ihour<24; ihour++){
			fin >> year >> month >> day >> hour >> xcol >> yrow;
			//ӁF~Jf[^̓vOœ삩i[
			for(int i=ROFnum_row-1; i>=0; i--){//Textf[^͖k
				for(int j=0; j<ROFnum_col; j++){
					fin >> fROF[i][j].value[iday][ihour] ;
				}
			}
		}
	}

	fin.close();
}

//	֐̒`
void read2DValueBinary(ROF** fROF, int Ndays, int ROFnum_row, int ROFnum_col)
{
	// read input data file arranged for two dimensional data. 

	char ROFfilename[256];

	//sprintf_s(ROFfilename, 256, "./input/rain.bin");
	sprintf(ROFfilename, "./input/rain.bin");
	cout << "Read " << ROFfilename << endl;

	ifstream fin(ROFfilename, ios::in | ios::binary);
	if(!fin){
		cout << "ROF file cannot open.\n";
		exit(1);
	}

	for(int iday=1; iday <= Ndays; iday++){
		for(int ihour=0; ihour<24; ihour++){
			//ӁF~Jf[^̓vOœ삩i[
//			for(int i=ROFnum_row-1; i>=0; i--){//Textf[^͖k
			for(int i=0; i<ROFnum_row; i++){//Binaryf[^͓삩
				for(int j=0; j<ROFnum_col; j++){
					fin.read((char *)(&fROF[i][j].value[iday][ihour]), sizeof(float));
				}
			}
		}
	}

	fin.close();
}
